org.apache.poi.xssf.model

## Class ExternalLinksTable

- java.lang.Object
- - org.apache.poi.ooxml.POIXMLDocumentPart
  - - org.apache.poi.xssf.model.ExternalLinksTable

-     public class ExternalLinksTable
      extends POIXMLDocumentPart

  Holds details of links to parts of other workbooks (eg named ranges), along with the most recently seen values for what they point to.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `protected class` | `ExternalLinksTable.ExternalName`

    - ### Nested classes/interfaces inherited from class org.apache.poi.ooxml.POIXMLDocumentPart

      `POIXMLDocumentPart.RelationPart`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ExternalLinksTable()`
    `ExternalLinksTable(PackagePart part)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected void` | `commit()` Save the content in the underlying package part.
    `org.openxmlformats.schemas.spreadsheetml.x2006.main.CTExternalLink` | `getCTExternalLink()` Returns the underlying xmlbeans object for the external link table
    `java.util.List<Name>` | `getDefinedNames()`
    `java.lang.String` | `getLinkedFileName()` Returns the last recorded name of the file that this is linked to
    `java.util.List<java.lang.String>` | `getSheetNames()`
    `void` | `readFrom(java.io.InputStream is)`
    `void` | `setLinkedFileName(java.lang.String target)` Updates the last recorded name for the file that this links to
    `void` | `writeTo(java.io.OutputStream out)`

    - ### Methods inherited from class org.apache.poi.ooxml.POIXMLDocumentPart

      `_invokeOnDocumentRead, addRelation, createRelationship, createRelationship, createRelationship, getNextPartNumber, getPackagePart, getParent, getRelationById, getRelationId, getRelationPartById, getRelationParts, getRelations, getTargetPart, isCommited, isCommitted, onDocumentCreate, onDocumentRead, onDocumentRemove, onSave, prepareForCommit, read, rebase, removeRelation, removeRelation, removeRelation, setCommited, setCommitted, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ExternalLinksTable

          public ExternalLinksTable()

    - #### ExternalLinksTable

          public ExternalLinksTable(PackagePart part)
                             throws java.io.IOException

      Throws:
        `java.io.IOException`
      Since:
        POI 3.14-Beta1

  - ### Method Detail

    - #### readFrom

          public void readFrom(java.io.InputStream is)
                        throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### writeTo

          public void writeTo(java.io.OutputStream out)
                       throws java.io.IOException

      Throws:
        `java.io.IOException`

    - #### commit

          protected void commit()
                         throws java.io.IOException

      Description copied from class: `POIXMLDocumentPart`
      Save the content in the underlying package part. Default implementation is empty meaning that the package part is left unmodified.

      Sub-classes should override and add logic to marshal the "model" into Ooxml4J.

      For example, the code saving a generic XML entry may look as follows:

           protected void commit() throws IOException {
             PackagePart part = getPackagePart();
             OutputStream out = part.getOutputStream();
             XmlObject bean = getXmlBean(); //the "model" which holds changes in memory
             bean.save(out, DEFAULT_XML_OPTIONS);
             out.close();
           }

      Overrides:
        `commit` in class `POIXMLDocumentPart`
      Throws:
        `java.io.IOException` - a subclass may throw an IOException if the changes can't be committed

    - #### getCTExternalLink

          public org.openxmlformats.schemas.spreadsheetml.x2006.main.CTExternalLink getCTExternalLink()

      Returns the underlying xmlbeans object for the external link table

    - #### getLinkedFileName

          public java.lang.String getLinkedFileName()

      Returns the last recorded name of the file that this is linked to

    - #### setLinkedFileName

          public void setLinkedFileName(java.lang.String target)

      Updates the last recorded name for the file that this links to

    - #### getSheetNames

          public java.util.List<java.lang.String> getSheetNames()

    - #### getDefinedNames

          public java.util.List<Name> getDefinedNames()

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.